diff --git a/pki/base/common/src/com/netscape/cms/profile/def/PolicyMappingsExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/PolicyMappingsExtDefault.java
index 183ef87bc0c57542d14db725b56753652a3f3272..1f05fef3e76368e6330cb0b3e0629b939539b909 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/PolicyMappingsExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/PolicyMappingsExtDefault.java
@@ -216,18 +216,16 @@ public class PolicyMappingsExtDefault extends EnrollExtDefault {
                 Vector<CertificatePolicyMap> policyMaps = new Vector<CertificatePolicyMap>();
 
                 for (int i = 0; i < size; i++) {
-                    NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-                    Enumeration<String> names = nvps.getNames();
+                    NameValuePairs nvps = v.elementAt(i);
 
-                    while (names.hasMoreElements()) {
-                        String name1 = (String) names.nextElement();
+                    for (String name1 : nvps.keySet()) {
 
                         if (name1.equals(ISSUER_POLICY_ID)) {
-                            issuerPolicyId = nvps.getValue(name1);
+                            issuerPolicyId = nvps.get(name1);
                         } else if (name1.equals(SUBJECT_POLICY_ID)) {
-                            subjectPolicyId = nvps.getValue(name1);
+                            subjectPolicyId = nvps.get(name1);
                         } else if (name1.equals(POLICY_ID_ENABLE)) {
-                            enable = nvps.getValue(name1);
+                            enable = nvps.get(name1);
                         }
                     }
 
@@ -327,13 +325,13 @@ public class PolicyMappingsExtDefault extends EnrollExtDefault {
                     CertificatePolicyId i1 = map.getIssuerIdentifier();
                     CertificatePolicyId s1 = map.getSubjectIdentifier();
 
-                    pairs.add(ISSUER_POLICY_ID, i1.getIdentifier().toString());
-                    pairs.add(SUBJECT_POLICY_ID, s1.getIdentifier().toString());
-                    pairs.add(POLICY_ID_ENABLE, "true");
+                    pairs.put(ISSUER_POLICY_ID, i1.getIdentifier().toString());
+                    pairs.put(SUBJECT_POLICY_ID, s1.getIdentifier().toString());
+                    pairs.put(POLICY_ID_ENABLE, "true");
                 } else {
-                    pairs.add(ISSUER_POLICY_ID, "");
-                    pairs.add(SUBJECT_POLICY_ID, "");
-                    pairs.add(POLICY_ID_ENABLE, "false");
+                    pairs.put(ISSUER_POLICY_ID, "");
+                    pairs.put(SUBJECT_POLICY_ID, "");
+                    pairs.put(POLICY_ID_ENABLE, "false");
 
                 }
                 recs.addElement(pairs);
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/SubjectDirAttributesExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/SubjectDirAttributesExtDefault.java
index a706fb4add235a55b9bb9a876188a0d6c0637954..cca5ab2344023bcd01a7d5d3acb77515e3fe4c6a 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/SubjectDirAttributesExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/SubjectDirAttributesExtDefault.java
@@ -220,19 +220,18 @@ public class SubjectDirAttributesExtDefault extends EnrollExtDefault {
                 Vector<Attribute> attrV = new Vector<Attribute>();
                 for (int i = 0; i < size; i++) {
                     NameValuePairs nvps = v.elementAt(i);
-                    Enumeration<String> names = nvps.getNames();
                     String attrName = null;
                     String attrValue = null;
                     String enable = "false";
-                    while (names.hasMoreElements()) {
-                        String name1 = names.nextElement();
+
+                    for (String name1 : nvps.keySet()) {
 
                         if (name1.equals(ATTR_NAME)) {
-                            attrName = nvps.getValue(name1);
+                            attrName = nvps.get(name1);
                         } else if (name1.equals(ATTR_VALUE)) {
-                            attrValue = nvps.getValue(name1);
+                            attrValue = nvps.get(name1);
                         } else if (name1.equals(ENABLE)) {
-                            enable = nvps.getValue(name1);
+                            enable = nvps.get(name1);
                         }
                     }
 
@@ -316,7 +315,7 @@ public class SubjectDirAttributesExtDefault extends EnrollExtDefault {
 
             while (e.hasMoreElements()) {
                 NameValuePairs pairs = new NameValuePairs();
-                pairs.add(ENABLE, "true");
+                pairs.put(ENABLE, "true");
                 Attribute attr = e.nextElement();
                 CMS.debug("SubjectDirAttributesExtDefault: getValue: attribute=" + attr);
                 ObjectIdentifier oid = attr.getOid();
@@ -325,9 +324,9 @@ public class SubjectDirAttributesExtDefault extends EnrollExtDefault {
                 String vv = map.getName(oid);
 
                 if (vv != null)
-                    pairs.add(ATTR_NAME, vv);
+                    pairs.put(ATTR_NAME, vv);
                 else
-                    pairs.add(ATTR_NAME, oid.toString());
+                    pairs.put(ATTR_NAME, oid.toString());
                 Enumeration<String> v = attr.getValues();
 
                 // just support single value for now
@@ -341,16 +340,16 @@ public class SubjectDirAttributesExtDefault extends EnrollExtDefault {
                     }
                 }
 
-                pairs.add(ATTR_VALUE, ss.toString());
+                pairs.put(ATTR_VALUE, ss.toString());
                 recs.addElement(pairs);
                 i++;
             }
 
             for (; i < num; i++) {
                 NameValuePairs pairs = new NameValuePairs();
-                pairs.add(ENABLE, "false");
-                pairs.add(ATTR_NAME, "GENERATIONQUALIFIER");
-                pairs.add(ATTR_VALUE, "");
+                pairs.put(ENABLE, "false");
+                pairs.put(ATTR_NAME, "GENERATIONQUALIFIER");
+                pairs.put(ATTR_VALUE, "");
                 recs.addElement(pairs);
             }
 
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/SubjectInfoAccessExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/SubjectInfoAccessExtDefault.java
index 670728e59ecbe4fb458367abc526587e977a4e36..104b29a083c554040ecf6c573d91eb2c708fc06f 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/SubjectInfoAccessExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/SubjectInfoAccessExtDefault.java
@@ -231,19 +231,17 @@ public class SubjectInfoAccessExtDefault extends EnrollExtDefault {
 
                 for (int i = 0; i < size; i++) {
                     NameValuePairs nvps = v.elementAt(i);
-                    Enumeration<String> names = nvps.getNames();
 
-                    while (names.hasMoreElements()) {
-                        String name1 = names.nextElement();
+                    for (String name1 : nvps.keySet()) {
 
                         if (name1.equals(AD_METHOD)) {
-                            method = nvps.getValue(name1);
+                            method = nvps.get(name1);
                         } else if (name1.equals(AD_LOCATION_TYPE)) {
-                            locationType = nvps.getValue(name1);
+                            locationType = nvps.get(name1);
                         } else if (name1.equals(AD_LOCATION)) {
-                            location = nvps.getValue(name1);
+                            location = nvps.get(name1);
                         } else if (name1.equals(AD_ENABLE)) {
-                            enable = nvps.getValue(name1);
+                            enable = nvps.get(name1);
                         }
                     }
 
@@ -347,18 +345,18 @@ public class SubjectInfoAccessExtDefault extends EnrollExtDefault {
                     des = ext.getAccessDescription(i);
                 }
                 if (des == null) {
-                    np.add(AD_METHOD, "");
-                    np.add(AD_LOCATION_TYPE, "");
-                    np.add(AD_LOCATION, "");
-                    np.add(AD_ENABLE, "false");
+                    np.put(AD_METHOD, "");
+                    np.put(AD_LOCATION_TYPE, "");
+                    np.put(AD_LOCATION, "");
+                    np.put(AD_ENABLE, "false");
                 } else {
                     ObjectIdentifier methodOid = des.getMethod();
                     GeneralName gn = des.getLocation();
 
-                    np.add(AD_METHOD, methodOid.toString());
-                    np.add(AD_LOCATION_TYPE, getGeneralNameType(gn));
-                    np.add(AD_LOCATION, getGeneralNameValue(gn));
-                    np.add(AD_ENABLE, "true");
+                    np.put(AD_METHOD, methodOid.toString());
+                    np.put(AD_LOCATION_TYPE, getGeneralNameType(gn));
+                    np.put(AD_LOCATION, getGeneralNameValue(gn));
+                    np.put(AD_ENABLE, "true");
                 }
                 recs.addElement(np);
             }
diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/ACLAdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/ACLAdminServlet.java
index 29088fc2d6374e078da7bd192a2ec1650653f06b..bde07533455902376659d0bc6e7c847ce1c49da1 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/ACLAdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/ACLAdminServlet.java
@@ -260,9 +260,9 @@ public class ACLAdminServlet extends AdminServlet {
             String desc = acl.getDescription();
 
             if (desc == null)
-                params.add(acl.getName(), "");
+                params.put(acl.getName(), "");
             else
-                params.add(acl.getName(), desc);
+                params.put(acl.getName(), desc);
         }
 
         sendResponse(SUCCESS, null, params, resp);
@@ -305,7 +305,7 @@ public class ACLAdminServlet extends AdminServlet {
                 }
             }
 
-            params.add(Constants.PR_ACL_OPS, rights.toString());
+            params.put(Constants.PR_ACL_OPS, rights.toString());
 
             Enumeration<ACLEntry> aclEntryEnum;
             aclEntryEnum = acl.entries();
@@ -323,7 +323,7 @@ public class ACLAdminServlet extends AdminServlet {
                 }
             }
 
-            params.add(Constants.PR_ACI, acis);
+            params.put(Constants.PR_ACI, acis);
 
             sendResponse(SUCCESS, null, params, resp);
             return;
@@ -472,7 +472,7 @@ public class ACLAdminServlet extends AdminServlet {
             IAccessEvaluator evaluator = res.nextElement();
 
             // params.add(evaluator.getType(), evaluator.getDescription());
-            params.add(evaluator.getType(), evaluator.getClass().getName());
+            params.put(evaluator.getType(), evaluator.getClass().getName());
         }
 
         sendResponse(SUCCESS, null, params, resp);
@@ -495,7 +495,7 @@ public class ACLAdminServlet extends AdminServlet {
                 str.append(operators[i]);
             }
 
-            params.add(evaluator.getType(), str.toString());
+            params.put(evaluator.getType(), str.toString());
         }
 
         sendResponse(SUCCESS, null, params, resp);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/AdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/AdminServlet.java
index 0e3d2c2283367596e4d19c01045bfee15d786d27..c7d7d619e2b5fe208756c4327bdc3c391ae66340 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/AdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/AdminServlet.java
@@ -21,7 +21,9 @@ import java.io.ByteArrayOutputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
 import java.security.cert.X509Certificate;
+import java.util.Collection;
 import java.util.Enumeration;
+import java.util.Iterator;
 import java.util.Locale;
 import java.util.StringTokenizer;
 
@@ -794,17 +796,17 @@ public class AdminServlet extends HttpServlet {
         StringBuffer buf = new StringBuffer();
 
         if (params != null) {
-            Enumeration<String> e = params.getNames();
+            Collection<String> names = params.keySet();
 
-            if (e.hasMoreElements()) {
-                while (e.hasMoreElements()) {
-                    String name = e.nextElement();
-                    String value = java.net.URLEncoder.encode((String)
-                            params.getValue(name));
+            if (!names.isEmpty()) {
+                for (Iterator<String> i = names.iterator(); i.hasNext(); ) {
+                    String name = i.next();
+                    String value = java.net.URLEncoder.encode(
+                            params.get(name));
 
                     buf.append(java.net.URLEncoder.encode(name) +
                             "=" + value);
-                    if (e.hasMoreElements())
+                    if (i.hasNext())
                         buf.append("&");
                 }
                 byte content[] = buf.toString().getBytes();
@@ -875,7 +877,7 @@ public class AdminServlet extends HttpServlet {
 
             //System.out.println(name);
             //System.out.println(name+","+config.getString(name));
-            params.add(name, config.getString(name));
+            params.put(name, config.getString(name));
         }
         sendResponse(SUCCESS, null, params, resp);
     }
@@ -925,7 +927,7 @@ public class AdminServlet extends HttpServlet {
         while (e.hasMoreElements()) {
             String s = e.nextElement();
 
-            params.add(s, config.getString(s));
+            params.put(s, config.getString(s));
         }
         sendResponse(SUCCESS, null, params, resp);
     }
@@ -1275,7 +1277,7 @@ public class AdminServlet extends HttpServlet {
             String paramName = s[i].substring(0, j);
             String args = s[i].substring(j + 1);
 
-            nvps.add(paramName, args);
+            nvps.put(paramName, args);
         }
         return nvps;
 
diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/AuthAdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/AuthAdminServlet.java
index 6a7ad959915df4739d7335e55e42cbf1ec2708fc..cacd0b5d00c2078c0c33b79cc7e88c3f37ff2004 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/AuthAdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/AuthAdminServlet.java
@@ -168,7 +168,7 @@ public class AuthAdminServlet extends AdminServlet {
                     // no need to authenticate this. if we're alive, return true.
                     NameValuePairs params = new NameValuePairs();
 
-                    params.add(Constants.PR_PING, Constants.TRUE);
+                    params.put(Constants.PR_PING, Constants.TRUE);
                     sendResponse(SUCCESS, null, params, resp);
                     return;
                 } else {
@@ -188,7 +188,7 @@ public class AuthAdminServlet extends AdminServlet {
                     String val = configStore.getString("authType", "pwd");
                     NameValuePairs params = new NameValuePairs();
 
-                    params.add("authType", val);
+                    params.put("authType", val);
                     sendResponse(SUCCESS, null, params, resp);
                     return;
                 }
@@ -856,7 +856,7 @@ public class AuthAdminServlet extends AdminServlet {
 
             NameValuePairs params = new NameValuePairs();
 
-            params.add(Constants.PR_AUTH_IMPL_NAME, implname);
+            params.put(Constants.PR_AUTH_IMPL_NAME, implname);
 
             // store a message in the signed audit log file
             auditMessage = CMS.getLogMessage(
@@ -921,7 +921,7 @@ public class AuthAdminServlet extends AdminServlet {
                     mAuths.getPlugins().get(name);
 
             if (value.isVisible()) {
-                params.add(name, value.getClassPath() + EDIT);
+                params.put(name, value.getClassPath() + EDIT);
             }
         }
         sendResponse(SUCCESS, null, params, resp);
@@ -948,9 +948,9 @@ public class AuthAdminServlet extends AdminServlet {
                     mAuths.getPlugins().get(value.getImplName());
 
             if (!amgrplugin.isVisible()) {
-                params.add(name, value.getImplName() + ";invisible;" + enableStr);
+                params.put(name, value.getImplName() + ";invisible;" + enableStr);
             } else {
-                params.add(name, value.getImplName() + ";visible;" + enableStr);
+                params.put(name, value.getImplName() + ";visible;" + enableStr);
             }
         }
         sendResponse(SUCCESS, null, params, resp);
@@ -1316,10 +1316,10 @@ public class AuthAdminServlet extends AdminServlet {
         NameValuePairs params = new NameValuePairs();
 
         // implName is always required so always send it.
-        params.add(Constants.PR_AUTH_IMPL_NAME, "");
+        params.put(Constants.PR_AUTH_IMPL_NAME, "");
         if (configParams != null) {
             for (int i = 0; i < configParams.length; i++) {
-                params.add(configParams[i], "");
+                params.put(configParams[i], "");
             }
         }
         sendResponse(0, null, params, resp);
@@ -1355,7 +1355,7 @@ public class AuthAdminServlet extends AdminServlet {
         String[] configParams = mgrInst.getConfigParams();
         NameValuePairs params = new NameValuePairs();
 
-        params.add(Constants.PR_AUTH_IMPL_NAME, mgrInst.getImplName());
+        params.put(Constants.PR_AUTH_IMPL_NAME, mgrInst.getImplName());
         // implName is always required so always send it.
         if (configParams != null) {
             for (int i = 0; i < configParams.length; i++) {
@@ -1363,9 +1363,9 @@ public class AuthAdminServlet extends AdminServlet {
                 String val = (String) config.get(key);
 
                 if (val != null) {
-                    params.add(key, val);
+                    params.put(key, val);
                 } else {
-                    params.add(key, "");
+                    params.put(key, "");
                 }
             }
         }
@@ -1501,7 +1501,7 @@ public class AuthAdminServlet extends AdminServlet {
             NameValuePairs saveParams = new NameValuePairs();
 
             // implName is always required so always include it it.
-            saveParams.add(IAuthSubsystem.PROP_PLUGIN,
+            saveParams.put(IAuthSubsystem.PROP_PLUGIN,
                     (String) oldConfig.get(IAuthSubsystem.PROP_PLUGIN));
             if (oldConfigParms != null) {
                 for (int i = 0; i < oldConfigParms.length; i++) {
@@ -1509,7 +1509,7 @@ public class AuthAdminServlet extends AdminServlet {
                     Object val = oldConfig.get(key);
 
                     if (val != null) {
-                        saveParams.add(key, (String) val);
+                        saveParams.put(key, (String) val);
                     }
                 }
             }
@@ -1711,11 +1711,8 @@ public class AuthAdminServlet extends AdminServlet {
         store.removeSubStore(id);
         IConfigStore rstore = store.makeSubStore(id);
 
-        Enumeration<String> keys = saveParams.getNames();
-
-        while (keys.hasMoreElements()) {
-            String key = (String) keys.nextElement();
-            String value = saveParams.getValue(key);
+        for (String key : saveParams.keySet()) {
+            String value = saveParams.get(key);
 
             if (value != null)
                 rstore.put(key, value);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/CAAdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/CAAdminServlet.java
index 5bcaa46d27714a29ae7b561db6148d7dd36a6e2a..e7b32e8440daa8aa7b8ea3322814831354ea1ce8 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/CAAdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/CAAdminServlet.java
@@ -243,10 +243,10 @@ public class CAAdminServlet extends AdminServlet {
                 continue;
             if (name.equals(Constants.PR_ENABLE))
                 continue;
-            params.add(name, rc.getString(name, ""));
+            params.put(name, rc.getString(name, ""));
         }
 
-        params.add(Constants.PR_ENABLE,
+        params.put(Constants.PR_ENABLE,
                 rc.getString(PROP_ENABLED, Constants.FALSE));
         sendResponse(SUCCESS, null, params, resp);
     }
@@ -304,10 +304,10 @@ public class CAAdminServlet extends AdminServlet {
                 continue;
             if (name.equals(Constants.PR_ENABLE))
                 continue;
-            params.add(name, riq.getString(name, ""));
+            params.put(name, riq.getString(name, ""));
         }
 
-        params.add(Constants.PR_ENABLE,
+        params.put(Constants.PR_ENABLE,
                 riq.getString(PROP_ENABLED, Constants.FALSE));
         sendResponse(SUCCESS, null, params, resp);
     }
@@ -462,8 +462,8 @@ public class CAAdminServlet extends AdminServlet {
                 String ipId = ip.getId();
 
                 if (ipId != null && ipId.length() > 0)
-                    params.add(ipId, ip.getDescription());
-                params.add(ipId + "." + Constants.PR_ENABLED,
+                    params.put(ipId, ip.getDescription());
+                params.put(ipId + "." + Constants.PR_ENABLED,
                         (Boolean.valueOf(ip.isCRLIssuingPointEnabled())).toString());
             }
         }
@@ -504,7 +504,7 @@ public class CAAdminServlet extends AdminServlet {
                     if (name.equals(Constants.PR_CLASS))
                         value = ip.getClass().getName();
 
-                    params.add(name, value);
+                    params.put(name, value);
                 }
             }
         }
@@ -552,7 +552,7 @@ public class CAAdminServlet extends AdminServlet {
                 sendResponse(ERROR, "Missing CRL IP name", null, resp);
                 return;
             }
-            params.add(Constants.PR_ID, ipId);
+            params.put(Constants.PR_ID, ipId);
 
             String desc = req.getParameter(Constants.PR_DESCRIPTION);
 
@@ -569,7 +569,7 @@ public class CAAdminServlet extends AdminServlet {
                 sendResponse(ERROR, "Missing CRL IP description", null, resp);
                 return;
             }
-            params.add(Constants.PR_DESCRIPTION, desc);
+            params.put(Constants.PR_DESCRIPTION, desc);
 
             String sEnable = req.getParameter(Constants.PR_ENABLED);
             boolean enable = true;
@@ -577,9 +577,9 @@ public class CAAdminServlet extends AdminServlet {
             if (sEnable != null && sEnable.length() > 0 &&
                     sEnable.equalsIgnoreCase(Constants.FALSE)) {
                 enable = false;
-                params.add(Constants.PR_ENABLED, Constants.FALSE);
+                params.put(Constants.PR_ENABLED, Constants.FALSE);
             } else {
-                params.add(Constants.PR_ENABLED, Constants.TRUE);
+                params.put(Constants.PR_ENABLED, Constants.TRUE);
             }
 
             IConfigStore crlSubStore =
@@ -708,7 +708,7 @@ public class CAAdminServlet extends AdminServlet {
                 sendResponse(ERROR, "Missing CRL IP name", null, resp);
                 return;
             }
-            params.add(Constants.PR_ID, ipId);
+            params.put(Constants.PR_ID, ipId);
 
             String desc = req.getParameter(Constants.PR_DESCRIPTION);
 
@@ -725,7 +725,7 @@ public class CAAdminServlet extends AdminServlet {
                 sendResponse(ERROR, "Missing CRL IP description", null, resp);
                 return;
             }
-            params.add(Constants.PR_DESCRIPTION, desc);
+            params.put(Constants.PR_DESCRIPTION, desc);
 
             String sEnable = req.getParameter(Constants.PR_ENABLED);
             boolean enable = true;
@@ -733,9 +733,9 @@ public class CAAdminServlet extends AdminServlet {
             if (sEnable != null && sEnable.length() > 0 &&
                     sEnable.equalsIgnoreCase(Constants.FALSE)) {
                 enable = false;
-                params.add(Constants.PR_ENABLED, Constants.FALSE);
+                params.put(Constants.PR_ENABLED, Constants.FALSE);
             } else {
-                params.add(Constants.PR_ENABLED, Constants.TRUE);
+                params.put(Constants.PR_ENABLED, Constants.TRUE);
             }
 
             IConfigStore crlSubStore =
@@ -1036,7 +1036,7 @@ public class CAAdminServlet extends AdminServlet {
                         continue;
                     String value = req.getParameter(name);
 
-                    params.add(name, value);
+                    params.put(name, value);
                 }
                 crlExts.setConfigParams(id, params, crlExtSubStore);
                 commit(true);
@@ -1125,7 +1125,7 @@ public class CAAdminServlet extends AdminServlet {
                         crlExtEnabled = crlExtSubStore.getBoolean(name, false);
                     }
                 }
-                params.add(extName, extName + ";visible;" + ((crlExtEnabled) ? "enabled" : "disabled"));
+                params.put(extName, extName + ";visible;" + ((crlExtEnabled) ? "enabled" : "disabled"));
             }
         }
 
@@ -1245,7 +1245,7 @@ public class CAAdminServlet extends AdminServlet {
                     continue;
                 String value = req.getParameter(name);
 
-                params.add(name, value);
+                params.put(name, value);
                 crlSubStore.putString(name, value);
             }
             boolean noRestart = ip.updateConfig(params);
@@ -1334,7 +1334,7 @@ public class CAAdminServlet extends AdminServlet {
                 continue;
             if (name.equals(Constants.PR_ENABLE))
                 continue;
-            params.add(name, crlSubStore.getString(name, ""));
+            params.put(name, crlSubStore.getString(name, ""));
         }
 
         getSigningAlgConfig(params);
@@ -1369,7 +1369,7 @@ public class CAAdminServlet extends AdminServlet {
                 if (name.equals(Constants.OP_TYPE))
                     continue;
 
-                params.add(name, caConnectorConfig.getString(name, ""));
+                params.put(name, caConnectorConfig.getString(name, ""));
             }
         }
         sendResponse(SUCCESS, null, params, resp);
@@ -1488,7 +1488,7 @@ public class CAAdminServlet extends AdminServlet {
         IConfigStore caConfig = mCA.getConfigStore();
 
         value = caConfig.getString(ICertificateAuthority.PROP_ENABLE_PAST_CATIME, "false");
-        params.add(Constants.PR_VALIDITY, value);
+        params.put(Constants.PR_VALIDITY, value);
 
         getSigningAlgConfig(params);
         getSerialConfig(params);
@@ -1498,7 +1498,7 @@ public class CAAdminServlet extends AdminServlet {
     }
 
     private void getSigningAlgConfig(NameValuePairs params) {
-        params.add(Constants.PR_DEFAULT_ALGORITHM,
+        params.put(Constants.PR_DEFAULT_ALGORITHM,
                 mCA.getDefaultAlgorithm());
         String[] algorithms = mCA.getCASigningAlgorithms();
         StringBuffer algorStr = new StringBuffer();
@@ -1511,16 +1511,16 @@ public class CAAdminServlet extends AdminServlet {
                 algorStr.append(algorithms[i]);
             }
         }
-        params.add(Constants.PR_ALL_ALGORITHMS, algorStr.toString());
+        params.put(Constants.PR_ALL_ALGORITHMS, algorStr.toString());
     }
 
     private void getSerialConfig(NameValuePairs params) {
-        params.add(Constants.PR_SERIAL,
+        params.put(Constants.PR_SERIAL,
                 mCA.getStartSerial());
     }
 
     private void getMaxSerialConfig(NameValuePairs params) {
-        params.add(Constants.PR_MAXSERIAL,
+        params.put(Constants.PR_MAXSERIAL,
                 mCA.getMaxSerial());
     }
 
